AIGameSettingControls.SupportRatio = class extends AIGameSettingControlFloat
{
	constructor(...args)
	{
		super(...args);
		this.defaultValue = 0.3;
		g_GameSettings.playerAI.watch(() => this.render(), ["values"]);
	}

	onOpenPage(playerIndex, enabled)
	{
		super.onOpenPage(playerIndex, enabled);
		this.render();
	}

	render()
	{
		const ai = g_GameSettings.playerAI.get(this.playerIndex);
		this.setHidden(!ai);
		if (ai)
		{
			const value = ai.economy?.supportRatio ?? this.defaultValue;
			this.setFloatValue(value);
		}
	}

	onValueChange(value)
	{
		const ai = g_GameSettings.playerAI.get(this.playerIndex);
		const economy = ai && ai.economy ? { ...ai.economy, "supportRatio": value } : { "supportRatio": value };
		g_GameSettings.playerAI.setEconomy(this.playerIndex, economy);
		this.gameSettingsController.setNetworkInitAttributes();
	}
};

AIGameSettingControls.SupportRatio.prototype.TitleCaption =
	translate("Support Ratio");
